PETSc version 3.15.5
Fix/Edit manual page

# VecCreateMPIViennaCLWithArray

Creates a parallel, array-style vector, where the user provides the viennacl vector to store the vector values.

### Synopsis

    #include "petscvec.h"
    PetscErrorCode  VecCreateMPIViennaCLWithArray(MPI_Comm comm,PetscInt bs,PetscInt n,PetscInt N,const ViennaCLVector *array,Vec *vv)

Collective

### Input Parameters

| comm | - the MPI communicator to use
| bs | - block size, same meaning as VecSetBlockSize()
| n | - local vector length, cannot be PETSC_DECIDE
| N | - global vector length (or PETSC_DECIDE to have calculated)
| array | - the user provided GPU array to store the vector values

### Output Parameter

| vv | - the vector

### Notes

Use VecDuplicate() or VecDuplicateVecs() to form additional vectors of the same type as an existing vector.

If the user-provided array is NULL, then VecViennaCLPlaceArray() can be used at a later stage to SET the array for storing the vector values.

PETSc does NOT free the array when the vector is destroyed via VecDestroy(). The user should not free the array until the vector is destroyed.

### See Also

VecCreateSeqViennaCLWithArray(), VecCreateMPIWithArray(), VecCreateSeqWithArray(),
VecCreate(), VecCreateMPI(), VecCreateGhostWithArray(), VecViennaCLPlaceArray()

### Level

intermediate

### Location

src/vec/vec/impls/mpi/mpiviennacl/mpiviennacl.cxx
Index of all Vec routines
Table of Contents for all manual pages
Index of all manual pages